#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, fnmatch, platform
from datetime import datetime

def find_files(directory, pattern):
	for root, dirs, files in os.walk(directory):
		for basename in files:
			if fnmatch.fnmatch(basename, pattern):
				filename = os.path.join(root, basename)
				yield filename


if len(sys.argv) != 2 and len(sys.argv) != 3:
	print "usage: pngout.py <source directory> [<output directory>]"
	sys.exit(1)

src = sys.argv[1]
if len(sys.argv) == 3:
	out = sys.argv[2]
else:
	out = src
src = os.path.abspath(src)
out = os.path.abspath(out)
if not os.path.exists(out):
	os.makedirs(out)


print 'Source directory:', src
print 'Output directory:', out

# calc size and compare

totalPng = 0
totalOldSize = 0
totalNewSize = 0
invalidFilesCnt = 0
beginTime = datetime.now()
y_arg = ' /y'

platformName = platform.system().lower()
if platformName == 'linux' or platformName == 'darwin':
	y_arg = ' -y'
for srcName in find_files(src, '*.png'):
	destName = srcName
	if out != '':
		destName = srcName.replace(src, out, 1)
	totalPng += 1
	totalOldSize += os.path.getsize(srcName)
	destDir = os.path.dirname(destName)
	if not os.path.exists(destDir):
		os.makedirs(destDir)
	print "pngout '" + srcName + "' '" + destName + "' /y"
	os.system('pngout "' + srcName + '" "' + destName + '"' + y_arg)
	if not os.path.exists(destName):
		print 'FILE NOT FOUND:', destName
		invalidFilesCnt += 1
		continue
	totalNewSize += os.path.getsize(destName)

print '------------------------------------'
print 'Processed', totalPng, 'files'
if totalPng > 0:
	print 'Total uncompressed size: ', totalOldSize
	print 'Total compressed size:', totalNewSize
	print 'Compression:', (totalOldSize - totalNewSize)/totalPng, 'bytes per file'
	if invalidFilesCnt > 0:
		print 'Errors:', invalidFilesCnt
print 'Elapsed time: ', (datetime.now() - beginTime)


